/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValueRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValue extends TableImpl<VCoreValueRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_value</code>
     */
    public static final VCoreValue V_CORE_VALUE = new VCoreValue();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValueRecord> getRecordType() {
        return VCoreValueRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_value.value_lang</code>.
     */
    public final TableField<VCoreValueRecord, String> VALUE_LANG = createField(DSL.name("value_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_value.varvalue</code>.
     */
    public final TableField<VCoreValueRecord, Integer> VARVALUE = createField(DSL.name("varvalue"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_value.value_order</code>.
     */
    public final TableField<VCoreValueRecord, Integer> VALUE_ORDER = createField(DSL.name("value_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_value.fk_value_valuelist</code>.
     */
    public final TableField<VCoreValueRecord, Integer> FK_VALUE_VALUELIST = createField(DSL.name("fk_value_valuelist"), SQLDataType.INTEGER, this, "");

    private VCoreValue(Name alias, Table<VCoreValueRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValue(Name alias, Table<VCoreValueRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_value" as  SELECT COALESCE(t_core_valueparam.param_key, ('Error! no paramKey for '::text || t_core_value.varvalue)) AS value_lang,
         t_core_value.varvalue,
         t_core_value.value_order,
         t_core_value.fk_value_valuelist
        FROM (common_dd.t_core_value
          RIGHT JOIN common_dd.t_core_valueparam ON ((t_core_valueparam.fk_valueparam_value = t_core_value.pk_core_value)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_value</code> table reference
     */
    public VCoreValue(String alias) {
        this(DSL.name(alias), V_CORE_VALUE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_value</code> table reference
     */
    public VCoreValue(Name alias) {
        this(alias, V_CORE_VALUE);
    }

    /**
     * Create a <code>common_dd.v_core_value</code> table reference
     */
    public VCoreValue() {
        this(DSL.name("v_core_value"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValue as(String alias) {
        return new VCoreValue(DSL.name(alias), this);
    }

    @Override
    public VCoreValue as(Name alias) {
        return new VCoreValue(alias, this);
    }

    @Override
    public VCoreValue as(Table<?> alias) {
        return new VCoreValue(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValue rename(String name) {
        return new VCoreValue(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValue rename(Name name) {
        return new VCoreValue(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValue rename(Table<?> name) {
        return new VCoreValue(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue where(Condition condition) {
        return new VCoreValue(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValue where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValue where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValue where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValue where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValue whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
